function parseSettingsFromJson(name) {
    let $block = $('#' + name);

    let settings = {};

    let settingsRaw = $.parseJSON($block.html() || '{}');
    $block.remove();
    return settingsRaw;
}

$(() => {
    var attendance = parseSettingsFromJson("json_attendance");
    console.log(attendance);
    var students = parseSettingsFromJson("json_students");
    console.log(students);
    var groups = parseSettingsFromJson("json_groups");
    console.log(groups);
    var discipline = parseSettingsFromJson("json_discipline");
    console.log(discipline);
    var lessons = parseSettingsFromJson("json_lessons");
    console.log(lessons);
    var lessonTypes = parseSettingsFromJson("json_lessonTypes");
    console.log(lessonTypes);
    var columnDescription = [
        {
            title: "ФИО",
            field: "fullName",
            frozen: true,
            width: 160
        },

    ];

    var studentList = Array();

    var fillFullNames = function (studentList) {
        studentList.forEach((student) => {
            student.fullName = [student.LastName, student.FirstName, student.SecondName].join(' ');
        })
    }

    let table = null;

    Object.keys(lessons).forEach((num) => {
        lesson = lessons[num];

        lessonDescription = {
            //title: lesson.LessonDate,
            title: `<input type="text" id="lesson_input_${lesson.ID}" class="lesson_input" value="${lesson.LessonDate}") }}">
                    <div class="delete_lesson" id="lesson_delete_${lesson.ID}"><span class="delete_lesson_icon"></span></div>`,
            field: "Lesson" + lesson.ID,
            headerVertical: false,
            editor: "tick", formatter:"tickCross",
            sortable: false, headerSort: false
        };
        columnDescription.push(lessonDescription);
    });

// TODO: bonus after total
    columnDescription.push({
        title: "Итого",
        field: "total",
        headerVertical: false,
    });

    Object.keys(students).forEach((groupID) => {
        fillFullNames(students[groupID]);
        students[groupID].forEach((student) => {
            student.groupID = groupID;
        });
        studentList.push(...students[groupID]);
    });

    studentList.forEach((student) => {
        recordBookID = student.RecordBookID;
        let totalAttendance = 0;
        if (attendance.hasOwnProperty(recordBookID)) {
            Object.keys(attendance[recordBookID]).forEach((lessonID) => {
                let propName = "Lesson" + lessonID;
                let attended = attendance[recordBookID][lessonID];
                student[propName] = attended;
                totalAttendance += attended;
            });
        }
        student.total = totalAttendance;
    });

    table = new Tabulator("#studentsAttendance", {
        columnVertAlign: "bottom", //align header contents to bottom of cell
        data: studentList,
        index: "RecordBookID",
        height: "800px",
        //layout: "fitColumns",
        persistentLayout: true,
        persistentSort: true,
        persistenceID: "DisciplineJournal" + discipline.ID,
        clipboard: true,
        history: true,
        historyUndo: function (action, component, data) {
            console.log(data);
            console.log(component);
            console.log(action);
            //action - the action that has been undone
            //component - the Component object afected by the action (colud be a row or cell component)
            //data - the data being changed
        },
        historyRedo: function (action, component, data) {
            console.log(data); // oldValue, newValue
            console.log(component);
            console.log(action); //cellEdit has action._cell.row/column
            //action - the action that has been redone
            //component - the Component object afected by the action (colud be a row or cell component)
            //data - the data being changed
        },
        clipboardPasteAction: "replace",
        columns: columnDescription,
        groupBy: "GroupID",
        groupHeader: function (value, count, data, group) {
            groupInfo = groups[value];
            return groupInfo.GroupNum + " группа " + groupInfo.GradeID + " курса";
        }
    });

    let currentYear = discipline.semesterYear;
    if (discipline.semesterNum === 2) {
        currentYear += 1
    }

    const defaultDate = new Date(Date.now());
    let numericYear = parseInt(currentYear);
    if (discipline.semesterNum === "2") {
        numericYear++;
    }
    defaultDate.setFullYear(numericYear);


    let $delete_lesson = $(".delete_lesson");
    let $switcher = $(".delete_button_switcher");
    $delete_lesson.hide();
    $(".rateHeader").on("click", ".delete_button_switcher", function () {
        if ($(".delete_button_switcher").hasClass("delete_mode")) {
            $(".delete_lesson").hide();
            $(".delete_button_switcher").removeClass("delete_mode")
        } else {
            $(".delete_button_switcher").addClass("delete_mode");
            $(".delete_lesson").show();
        }
    });

    $.datepicker.setDefaults(
        $.extend(
            {'dateFormat':'dd-mm'},
            $.datepicker.regional['ru']
        )
    );


    let $cell = undefined;
    const setDateTimePickerHandlers = function ($elem) {
        let oldDateText = $elem.val();
        $cell = $elem;
        //$elem.datetimepicker({
        $elem.datepicker({
            dateFormat: 'dd-mm',
            changeMonth: true,
            changeYear: false,
            defaultDate: defaultDate,
            //timeFormat: 'HH:mm:ss',
            beforeShow: function() {
                oldDateText = $(this).val();
                $cell = this;
            },
            onClose: function(dateText) {
                //onDateInput($(this), dateText, oldDateText);
            }
        });
        // $elem.on("change", {}, $elem.dattetimepicker()) ломает datetimepicker в Chrome:
        // jquery-1.11.1.min.js:3 Uncaught TypeError: ((m.event.special[e.origType] || {}).handle || e.handler).apply is not a function
        //     at HTMLInputElement.dispatch (jquery-1.11.1.min.js:3)
        //     at HTMLInputElement.r.handle (jquery-1.11.1.min.js:3)
        //     at Object.trigger (jquery-1.11.1.min.js:3)
        //     at HTMLInputElement.<anonymous> (jquery-1.11.1.min.js:3)
        //     at Function.each (jquery-1.11.1.min.js:2)
        //     at m.fn.init.each (jquery-1.11.1.min.js:2)
        //     at m.fn.init.trigger (jquery-1.11.1.min.js:3)
        //     at Timepicker._updateDateTime (jquery-timepicker-addon-1.6.3.js:987)
        //     at Datepicker.$.datepicker._formatDate (jquery-timepicker-addon-1.6.3.js:1808)
        //     at Datepicker._selectDay (jquery-ui.js:8191)
        // $elem.on("change", {}, $elem.datetimepicker());
        //$elem.change().datetimepicker();
        $elem.change().datepicker();
    };
    setDateTimePickerHandlers($(".lesson_input"));


//trigger download of data.xlsx file
    $("#download-xlsx").click(function () {
        table.download("xlsx", "data.xlsx", {sheetName: "My Data"});
    });

//trigger download of data.pdf file
    $("#download-pdf").click(function () {
        //table.download("pdf", "data.pdf", {
        //autoTable: function(doc) {
        // need to use https://github.com/sphilee/jsPDF-CustomFonts-support to generate base64-encoded string
//    doc.addFileToVFS("fontawesome-webfont.ttf", "AAEAAAAOAIAAAwBgRkZUTW..."); // your font in binary format as second parameter
        //doc.addFont("fontawesome-webfont.ttf", "FontAwesome", "normal");
        //doc.setFont("FontAwesome");
        //return {
//      styles: {
        //font: "FontAwesome",
        //fontStyle: "normal"
        //}
        //};
        //}
//});
        table.download("pdf", "data.pdf", {
            orientation: "portrait", //set page orientation to portrait
            title: "Example Report", //add title to report
        });
    });


//TODO: use history callbacks to track changes when using undo/redo
//http://tabulator.info/docs/4.2/callbacks#history

//undo button
    $("#history-undo").on("click", function () {
        table.undo();
    });

//redo button
    $("#history-redo").on("click", function () {
        table.redo();
    });

    $("#new-lesson").on("click", function () {

    });

});
